<template>
    <v-container fluid>
        <v-col lg="4" class="mx-auto" md="12" sm="12">
            <v-card outlined class="pa-3 mx-auto" :elevation="4">
                <v-alert v-if="err != ''" dense text type="error">
                    {{err}}
                </v-alert>
                <v-alert v-if="ok != ''" dense text type="success">
                    {{success}}
                </v-alert>
                <v-card-title>Create Trigger</v-card-title>
                <v-card-text>

                    <v-form ref='form' v-model="valid">
                        <v-row>
                            <v-text-field label="Trigger Name"
                                          name="Trigger Name"
                                          :counter="64"
                                          v-model="name"
                                          :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.trigger' :''"
                                          :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.trigger' : ''"
                                          required
                                          :rules="rules"
                                          type="text"/>
                        </v-row>
                        <v-row>
                            <v-text-field label="Trigger Description"
                                          name="Trigger Description"
                                          v-model="description"
                                          :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.desc' :''"
                                          :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.desc' : ''"
                                          required
                                          :rules="required"
                                          type="text"/>
                        </v-row>
                        <v-row>
                            <v-select
                                    label="Trigger Type"
                                    name="Trigger Type"
                                    :items="TriggerType"
                                    v-model="type"
                                    item-value="value"
                                    item-text="name"
                                    :hint="Hint"
                                    persistent-hint
                                    required
                                    :rules="required"
                                    single-line
                                    :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.triggerType' :''"
                                    :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.triggerType' : ''"
                            />
                        </v-row>
                        <v-row>
                            <v-combobox v-model="labels"
                                        :items="existingLabels"
                                        label="Labels"
                                        name="Labels"
                                        :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.label' :''"
                                        :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.label' : ''"
                                        hint="Add existing or create new labels"
                                        persistent-hint
                                        multiple>
                                <template v-slot:selection="data">
                                    <v-chip
                                            :key="JSON.stringify(data.item)"
                                            v-bind="data.attrs"
                                            :input-value="data.selected"
                                            :disabled="data.disabled"
                                            @click:close="data.parent.selectItem(data.item)"
                                    >
                                        <v-avatar
                                                class="accent white--text"
                                                left
                                                v-text="data.item.slice(0, 1).toUpperCase()"
                                        ></v-avatar>
                                        {{ data.item }}
                                    </v-chip>
                                </template>

                            </v-combobox>
                        </v-row>
                        <v-row>
                            <v-textarea ref='ta' label="Trigger Code"
                                        name="Trigger Code"
                                        v-model="code"
                                        :rules="required"
                                        :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.code' :''"
                                        :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.code' : ''"
                                        required
                                        type="text"/>
                        </v-row>
                    </v-form>
                </v-card-text>
                <v-card-actions>
                    <v-btn color="primary" to="/trigger">
                        Back
                    </v-btn>
                    <v-spacer/>
                    <v-btn color="primary" :disabled="!valid" @click="Create">
                        Create
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-col>


    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component} from 'vue-property-decorator';
    import {Validable} from "../../mixins/Validable";
    import {Initializable} from "../../mixins/Initializable";
    import {Mixins} from "vue-mixin-decorator";
    import {coreApi, triggerType} from "../../init";
    import {TriggerResponse} from "../../../../classLibrary/core/triggerResponse";


    interface AnalyticsMixin extends Validable, Initializable {
    }

    @Component
    export default class CreateTrigger extends Mixins<AnalyticsMixin>(Validable, Initializable) {
        valid: boolean = false;

        rules = [
            (v: any) => !!v || 'Trigger Name is required',
            (v: any) => (v && v.length >= 4) || 'Trigger Name must be at least 4 characters long',
            (v: any) => (v && v.length <= 64) || 'Trigger Name cannot exceed 64 characters long',
        ]
        required = [
            (v: any) => !!v || 'Required',
        ]

        name: string = '';
        code: string = '';
        description: string = '';
        type: string = '';
        labels: string[] = [];

        existingLabels: string[] = [];

        async init() {
            const e = await coreApi.Get<string[]>('Trigger/labels');
            if (e.success) {
                this.existingLabels = e.Ok!;
            }
        }

        async mounted() {

            const c = (this.$refs['ta']! as any).$el as HTMLDivElement;
            const e = c.querySelector('textarea');
            e?.addEventListener('keydown', function (e: KeyboardEvent): any {
                if (e.keyCode == 9) {
                    document.execCommand('insertText', false, ' '.repeat(4))
                    if (e.preventDefault) {
                        e.preventDefault();
                    }
                    return false;
                }
            }, false)

        }

        get Hint(): string {
            return this.TriggerType
                .Find(x => x.value === this.type)?.desc ?? ""
        }

        get TriggerType(): { name: string, value: string, desc: string }[] {
            return triggerType;
        }


        async Create() {
            if (this.valid) {
                console.log(this.name, this.description, this.labels, this.code, this.type)

                const r = await coreApi.Post<TriggerResponse>("Trigger", {
                    name: this.name,
                    description: this.description,
                    labels: this.labels,
                    code: this.code,
                    type: this.type,
                    meta: JSON.stringify({}),
                });
                if (r.success) {
                    this.ok = "Successfully created Trigger!";
                    // await this.$router.push(`/trigger/${r.Ok!.id}`);
                } else {
                    this.err = r.error!;
                }

            }
        }
    }
</script>
